package uk.ac.shef.is.imageClef.clusterAssessment;

/** Class is a container to store the information of
 * a image (docNr) to which cluster it belongs. A typical 
 * line from the cluster assessment file looks like this:
 * "13  1 15/15905"
 * @author Thomas Arni
 *
 */
public class ClusterAssessmentLineContainer {
	private String topicNr;
	private String clusterId;
	private String docNr;
	
	public ClusterAssessmentLineContainer(String topicNr, String docNr, String clusterId){
		this.topicNr = topicNr;
		this.clusterId = clusterId;
		this.docNr = docNr;
	}
	
	public String getClusterId() {
		return clusterId;
	}

	public String getDocNr() {
		return docNr;
	}

	public String getTopicNr() {
		return topicNr;
	}

	public void setTopicNr(String topicNr) {
		this.topicNr = topicNr;
	}
}
