package uk.ac.shef.is.imageClef.clusterAssessment;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class ClusterAssessmentParser {
	private static boolean print = false;
	
	public static ClusterAssessmentsContainer parse(File fileToParse){
		ClusterAssessmentsContainer allAssessments = new ClusterAssessmentsContainer();		
		try {
			BufferedReader input = new BufferedReader(new InputStreamReader(
					new FileInputStream(fileToParse)));
			try {
				String line = null;
				while ((line = input.readLine()) != null) {
					if(print) System.out.println(line);
					ClusterAssessmentLineContainer cac = parseClusterAssessmentLine(line);
					if(cac != null){
						allAssessments.add(cac);
				
					}
//					else System.err.println("Error : ClusterAssessmentContainer is NULL");
				}
			} finally {
				input.close();
			}
		} catch (IOException ex) {
			ex.printStackTrace();
		}	
		return allAssessments;
	}
	
	public static String getClusterLabelByTopicAndClusterId(File fileToParse, String topicNr, String clusterId){
		try {
			BufferedReader input = new BufferedReader(new InputStreamReader(
					new FileInputStream(fileToParse)));
			try {
				String line = null; //not declared within while loop
				while ((line = input.readLine()) != null) {

				    String patternClusterDescription = "#\\WT"+topicNr+"\\W"+clusterId+"\\W.\\W(.*)\\W\\((.*)\\)";
					Pattern pattern2 = Pattern.compile(patternClusterDescription);
				    Matcher matcher2 = pattern2.matcher(line);	    
				    if(matcher2.find()){
//						System.out.println(fileToParse.getAbsolutePath() + " " + line);
				    	String clusterLabel = matcher2.group(1);
				    	String clusterCount = matcher2.group(2);
				    	return clusterLabel + ";" + clusterCount; 
				    }				
				}
			} finally {
				input.close();
			}
		} catch (IOException ex) {
			ex.printStackTrace();
		}	
		return "Error : No cluster descripton found";
	}

	private static ClusterAssessmentLineContainer parseClusterAssessmentLine(String line){
		String patternClusterAssessment = "([0-9]{1,2})\\W([0-9]{1,2})\\W([0-9]{1,2}/[0-9]{1,5}).*";
		Pattern pattern1 = Pattern.compile(patternClusterAssessment);
	    Matcher matcher1 = pattern1.matcher(line);
	    
	    if(matcher1.find()){
	    	String topicNr = matcher1.group(1);    	
	    	String cluster = matcher1.group(2);
	    	String docNr = matcher1.group(3);
//	    	System.err.println("/////////"+docNr);
	    	boolean correctTopicNr = false;
	    	boolean correctDocNr = false;
	    	boolean correctCluster = false;
	    	
		    if(topicNr != null && topicNr.length() > 0){
		    	correctTopicNr = true;
		    	if(print)System.out.println("topicNr:"+topicNr);
		    }
		    else System.err.println("Could not get topicNr for line: " + line);
		    
		    if(docNr != null && docNr.length() > 0){
		    	correctDocNr = true;
		    	if(print)System.out.println("docNr:"+docNr);
		    }
		    else System.err.println("Could not get docNr for line: "  + line);	
		    
		    if(cluster != null && cluster.length() > 0){
		    	correctCluster = true;
		    	if(print)System.out.println("cluster:"+cluster);
		    }
		    else System.err.println("Could not get rank for line: " + line );	
		    
		    if(correctDocNr && correctCluster && correctTopicNr){
		    	return new ClusterAssessmentLineContainer(topicNr,docNr,cluster);
		    }
		    else{
		    	System.err.println("Could not create ClusterAssessmentContainer on line: " + line );
		    	return null;
		    }
	    }
	    else {
	    	return null;
	    }
	}
}