package uk.ac.shef.is.imageClef.clusterAssessment;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;

/** Class is container of one topic of the cluster assessments
 * @author Thomas Arni
 *
 */
public class ClusterTopicAssessmentsContainer {
	private String topicNr = null;
	private ArrayList<ClusterAssessmentLineContainer> assessments = new ArrayList<ClusterAssessmentLineContainer>();
	
	public ClusterTopicAssessmentsContainer(String topicNr){
		this.topicNr = topicNr;
	}
	
	public void add(ClusterAssessmentLineContainer cac){
		assessments.add(cac);
	}

	public String getTopicNr() {
		return topicNr;
	}

	public void setTopicNr(String topicNr) {
		this.topicNr = topicNr;
	}

	public ArrayList<ClusterAssessmentLineContainer> getAssessments() {
		return assessments;
	}

	public void setAssessments(ArrayList<ClusterAssessmentLineContainer> assessments) {
		this.assessments = assessments;
	}
	
	public String getClusterIdByDocNrAndTopicNr(String docNr){
		for(int j = 0;j<assessments.size();j++){
			ClusterAssessmentLineContainer cac = assessments.get(j);
			if(cac.getDocNr().equals(docNr)){
				return cac.getClusterId();
			}
		}
		return null;
	}
	
	public void printClustersCount(File clusterAssessmentFile){
		HashMap<String, Integer> clusterCount = new HashMap<String, Integer>();
		for(int j = 0;j<assessments.size();j++){
			ClusterAssessmentLineContainer cac = assessments.get(j);
			String clusterId = cac.getClusterId();
			if(!clusterCount.containsKey(clusterId)){
				clusterCount.put(clusterId, new Integer(1));
			}
			else{
				int t = clusterCount.get(clusterId);
				clusterCount.put(clusterId, ++t);
			}
		}
		int numberOfClusters = clusterCount.entrySet().size();
		for(int n = 1; n <= numberOfClusters; n++){
			if(clusterCount.containsKey(""+n)){
				int cC = clusterCount.get(""+n);
				System.out.println("T"+topicNr + ";" + n + "-" +ClusterAssessmentParser.getClusterLabelByTopicAndClusterId(clusterAssessmentFile, topicNr, ""+n) + ";" + cC);
			}
			else{
				System.err.println("T"+topicNr + " " + n + " has no Images in cluster");
			}
		}
	}	
	
	/** Returns the number of clusters for the current topic
	 * @return number 
	 */
	public int getNumberOfClusters(){
		HashMap<String, Integer> clusterCount = new HashMap<String, Integer>();
		for(int j = 0;j<assessments.size();j++){
			ClusterAssessmentLineContainer cac = assessments.get(j);
			String clusterId = cac.getClusterId();
			if(!clusterCount.containsKey(clusterId)){
				clusterCount.put(clusterId, new Integer(1));
			}
			else{
				int t = clusterCount.get(clusterId);
				clusterCount.put(clusterId, ++t);
			}
		}
		int numberOfClusters = clusterCount.entrySet().size();
		return numberOfClusters;
	}	
}
